Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/DefaultSymbolicExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/DefaultSymbolicExpressionGrammar.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/DefaultSymbolicExpressionGrammar.cs	(revision 3338)
@@ -34,77 +34,152 @@
   public class DefaultSymbolicExpressionGrammar : Item, ISymbolicExpressionGrammar {
     [Storable]
-    private int minFunctionDefinitions;
-    [Storable]
-    private int maxFunctionDefinitions;
-    [Storable]
-    private int minFunctionArguments;
-    [Storable]
-    private int maxFunctionArguments;
-
-    [Storable]
     private Dictionary<string, int> minSubTreeCount;
     [Storable]
     private Dictionary<string, int> maxSubTreeCount;
     [Storable]
-    private Dictionary<string, List<HashSet<string>>> allowedFunctions;
+    private Dictionary<string, List<HashSet<string>>> allowedChildSymbols;
     [Storable]
     private HashSet<Symbol> allSymbols;
 
-    public DefaultSymbolicExpressionGrammar(int minFunctionDefinitions, int maxFunctionDefinitions, int minFunctionArguments, int maxFunctionArguments)
+    public DefaultSymbolicExpressionGrammar()
       : base() {
-      this.minFunctionDefinitions = minFunctionDefinitions;
-      this.maxFunctionDefinitions = maxFunctionDefinitions;
-      this.minFunctionArguments = minFunctionArguments;
-      this.maxFunctionArguments = maxFunctionArguments;
+      Reset();
+    }
+
+    private void Initialize() {
+      startSymbol = new StartSymbol();
+      AddSymbol(startSymbol);
+      SetMinSubtreeCount(startSymbol, 1);
+      SetMaxSubtreeCount(startSymbol, 1);
+    }
+
+    #region ISymbolicExpressionGrammar Members
+
+    private Symbol startSymbol;
+    public Symbol StartSymbol {
+      get { return startSymbol; }
+      set { startSymbol = value; }
+    }
+
+    protected void Reset() {
       minSubTreeCount = new Dictionary<string, int>();
       maxSubTreeCount = new Dictionary<string, int>();
-      allowedFunctions = new Dictionary<string, List<HashSet<string>>>();
+      allowedChildSymbols = new Dictionary<string, List<HashSet<string>>>();
       allSymbols = new HashSet<Symbol>();
-      cachedMinExpressionLength = new Dictionary<Symbol, int>();
-      cachedMaxExpressionLength = new Dictionary<Symbol, int>();
-      cachedMinExpressionDepth = new Dictionary<Symbol, int>();
+      cachedMinExpressionLength = new Dictionary<string, int>();
+      cachedMaxExpressionLength = new Dictionary<string, int>();
+      cachedMinExpressionDepth = new Dictionary<string, int>();
       Initialize();
     }
 
-    private void Initialize() {
-      programRootSymbol = new ProgramRootSymbol();
-      var defunSymbol = new Defun();
-      startSymbol = new StartSymbol();
-      var invokeFunctionSymbol = new InvokeFunction();
-
-      SetMinSubTreeCount(programRootSymbol, minFunctionDefinitions + 1);
-      SetMaxSubTreeCount(programRootSymbol, maxFunctionDefinitions + 1);
-      SetMinSubTreeCount(startSymbol, 1);
-      SetMaxSubTreeCount(startSymbol, 1);
-      SetMinSubTreeCount(defunSymbol, 1);
-      SetMaxSubTreeCount(defunSymbol, 1);
-      SetMinSubTreeCount(invokeFunctionSymbol, minFunctionArguments);
-      SetMaxSubTreeCount(invokeFunctionSymbol, maxFunctionArguments);
-      AddAllowedSymbols(programRootSymbol, 0, startSymbol);
-      for (int argumentIndex = 1; argumentIndex < maxFunctionDefinitions + 1; argumentIndex++) {
-        AddAllowedSymbols(programRootSymbol, argumentIndex, defunSymbol);
-      }
-    }
-
-    public void AddAllowedSymbols(Symbol parent, int argumentIndex, Symbol allowedChild) {
-      allSymbols.Add(parent); allSymbols.Add(allowedChild);
-      if (!allowedFunctions.ContainsKey(parent.Name)) {
-        allowedFunctions[parent.Name] = new List<HashSet<string>>();
-      }
-      while (allowedFunctions[parent.Name].Count <= argumentIndex)
-        allowedFunctions[parent.Name].Add(new HashSet<string>());
-      allowedFunctions[parent.Name][argumentIndex].Add(allowedChild.Name);
-      ClearCaches();
-    }
-
-    public void SetMaxSubTreeCount(Symbol parent, int nSubTrees) {
-      maxSubTreeCount[parent.Name] = nSubTrees;
-      ClearCaches();
-    }
-
-    public void SetMinSubTreeCount(Symbol parent, int nSubTrees) {
-      minSubTreeCount[parent.Name] = nSubTrees;
-      ClearCaches();
-    }
+    public void AddSymbol(Symbol symbol) {
+      if (allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Symbol " + symbol + " is already defined.");
+      allSymbols.Add(symbol);
+      allowedChildSymbols[symbol.Name] = new List<HashSet<string>>();
+      ClearCaches();
+    }
+
+    public void RemoveSymbol(Symbol symbol) {
+      allSymbols.RemoveWhere(s => s.Name == symbol.Name);
+      minSubTreeCount.Remove(symbol.Name);
+      maxSubTreeCount.Remove(symbol.Name);
+      allowedChildSymbols.Remove(symbol.Name);
+      ClearCaches();
+    }
+
+    public IEnumerable<Symbol> Symbols {
+      get { return allSymbols.AsEnumerable(); }
+    }
+
+    public void SetAllowedChild(Symbol parent, Symbol child, int argumentIndex) {
+      if (!allSymbols.Any(s => s.Name == parent.Name)) throw new ArgumentException("Unknown symbol: " + parent, "parent");
+      if (!allSymbols.Any(s => s.Name == child.Name)) throw new ArgumentException("Unknown symbol: " + child, "child");
+      if (argumentIndex >= GetMaxSubtreeCount(parent)) throw new ArgumentException("Symbol " + parent + " can have only " + GetMaxSubtreeCount(parent) + " subtrees.");
+      allowedChildSymbols[parent.Name][argumentIndex].Add(child.Name);
+      ClearCaches();
+    }
+
+    public bool IsAllowedChild(Symbol parent, Symbol child, int argumentIndex) {
+      if (!allSymbols.Any(s => s.Name == parent.Name)) throw new ArgumentException("Unknown symbol: " + parent, "parent");
+      if (!allSymbols.Any(s => s.Name == child.Name)) throw new ArgumentException("Unknown symbol: " + child, "child");
+      if (argumentIndex >= GetMaxSubtreeCount(parent)) throw new ArgumentException("Symbol " + parent + " can have only " + GetMaxSubtreeCount(parent) + " subtrees.");
+      if (allowedChildSymbols.ContainsKey(parent.Name)) return allowedChildSymbols[parent.Name][argumentIndex].Contains(child.Name);
+      return false;
+    }
+
+    private Dictionary<string, int> cachedMinExpressionLength;
+    public int GetMinExpressionLength(Symbol symbol) {
+      if (!allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Unknown symbol: " + symbol);
+      if (!cachedMinExpressionLength.ContainsKey(symbol.Name)) {
+        cachedMinExpressionLength[symbol.Name] = int.MaxValue; // prevent infinite recursion
+        long sumOfMinExpressionLengths = 1 + (from argIndex in Enumerable.Range(0, GetMinSubtreeCount(symbol))
+                                              let minForSlot = (long)(from s in allSymbols
+                                                                      where IsAllowedChild(symbol, s, argIndex)
+                                                                      select GetMinExpressionLength(s)).DefaultIfEmpty(0).Min()
+                                              select minForSlot).DefaultIfEmpty(0).Sum();
+
+        cachedMinExpressionLength[symbol.Name] = (int)Math.Min(sumOfMinExpressionLengths, int.MaxValue);
+      }
+      return cachedMinExpressionLength[symbol.Name];
+    }
+
+    private Dictionary<string, int> cachedMaxExpressionLength;
+    public int GetMaxExpressionLength(Symbol symbol) {
+      if (!allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Unknown symbol: " + symbol);
+      if (!cachedMaxExpressionLength.ContainsKey(symbol.Name)) {
+        cachedMaxExpressionLength[symbol.Name] = int.MaxValue; // prevent infinite recursion
+        long sumOfMaxTrees = 1 + (from argIndex in Enumerable.Range(0, GetMaxSubtreeCount(symbol))
+                                  let maxForSlot = (long)(from s in allSymbols
+                                                          where IsAllowedChild(symbol, s, argIndex)
+                                                          select GetMaxExpressionLength(s)).DefaultIfEmpty(0).Max()
+                                  select maxForSlot).DefaultIfEmpty(0).Sum();
+        long limit = int.MaxValue;
+        cachedMaxExpressionLength[symbol.Name] = (int)Math.Min(sumOfMaxTrees, limit);
+      }
+      return cachedMaxExpressionLength[symbol.Name];
+    }
+
+    private Dictionary<string, int> cachedMinExpressionDepth;
+    public int GetMinExpressionDepth(Symbol symbol) {
+      if (!allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Unknown symbol: " + symbol);
+      if (!cachedMinExpressionDepth.ContainsKey(symbol.Name)) {
+        cachedMinExpressionDepth[symbol.Name] = int.MaxValue; // prevent infinite recursion
+        cachedMinExpressionDepth[symbol.Name] = 1 + (from argIndex in Enumerable.Range(0, GetMinSubtreeCount(symbol))
+                                                     let minForSlot = (from s in allSymbols
+                                                                       where IsAllowedChild(symbol, s, argIndex)
+                                                                       select GetMinExpressionDepth(s)).DefaultIfEmpty(0).Min()
+                                                     select minForSlot).DefaultIfEmpty(0).Max();
+      }
+      return cachedMinExpressionDepth[symbol.Name];
+    }
+
+    public void SetMaxSubtreeCount(Symbol symbol, int nSubTrees) {
+      if (!allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Unknown symbol: " + symbol);
+      maxSubTreeCount[symbol.Name] = nSubTrees;
+      while (allowedChildSymbols[symbol.Name].Count <= nSubTrees)
+        allowedChildSymbols[symbol.Name].Add(new HashSet<string>());
+      while (allowedChildSymbols[symbol.Name].Count > nSubTrees) {
+        allowedChildSymbols[symbol.Name].RemoveAt(allowedChildSymbols[symbol.Name].Count - 1);
+      }
+      ClearCaches();
+    }
+
+    public void SetMinSubtreeCount(Symbol symbol, int nSubTrees) {
+      if (!allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Unknown symbol: " + symbol);
+      minSubTreeCount[symbol.Name] = nSubTrees;
+      ClearCaches();
+    }
+
+    public int GetMinSubtreeCount(Symbol symbol) {
+      if (!allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Unknown symbol: " + symbol);
+      return minSubTreeCount[symbol.Name];
+    }
+
+    public int GetMaxSubtreeCount(Symbol symbol) {
+      if (!allSymbols.Any(s => s.Name == symbol.Name)) throw new ArgumentException("Unknown symbol: " + symbol);
+      return maxSubTreeCount[symbol.Name];
+    }
+
+    #endregion
 
     private void ClearCaches() {
@@ -114,123 +189,27 @@
     }
 
-    private void symbol_ToStringChanged(object sender, EventArgs e) {
-      OnToStringChanged();
-    }
-
-    #region ISymbolicExpressionGrammar Members
-
-    private Symbol programRootSymbol;
-    public Symbol ProgramRootSymbol {
-      get { return programRootSymbol; }
-    }
-
-    private Symbol startSymbol;
-    public Symbol StartSymbol {
-      get { return startSymbol; }
-    }
-
-    public IEnumerable<Symbol> GetAllowedSymbols(Symbol parent, int argumentIndex) {
-      return from name in allowedFunctions[parent.Name][argumentIndex]
-             from sym in allSymbols
-             where name == sym.Name
-             select sym;
-    }
-
-
-    private Dictionary<Symbol, int> cachedMinExpressionLength;
-    public int GetMinExpressionLength(Symbol start) {
-      if (!cachedMinExpressionLength.ContainsKey(start)) {
-        cachedMinExpressionLength[start] = int.MaxValue; // prevent infinite recursion
-        cachedMinExpressionLength[start] = 1 + (from argIndex in Enumerable.Range(0, GetMinSubTreeCount(start))
-                                                let minForSlot = (from symbol in GetAllowedSymbols(start, argIndex)
-                                                                  select GetMinExpressionLength(symbol)).DefaultIfEmpty(0).Min()
-                                                select minForSlot).DefaultIfEmpty(0).Sum();
-      }
-      return cachedMinExpressionLength[start];
-    }
-
-    private Dictionary<Symbol, int> cachedMaxExpressionLength;
-    public int GetMaxExpressionLength(Symbol start) {
-      if (!cachedMaxExpressionLength.ContainsKey(start)) {
-        cachedMaxExpressionLength[start] = int.MaxValue; // prevent infinite recursion
-        long sumOfMaxTrees = 1 + (from argIndex in Enumerable.Range(0, GetMaxSubTreeCount(start))
-                                  let maxForSlot = (long)(from symbol in GetAllowedSymbols(start, argIndex)
-                                                          select GetMaxExpressionLength(symbol)).DefaultIfEmpty(0).Max()
-                                  select maxForSlot).DefaultIfEmpty(0).Sum();
-        long limit = int.MaxValue;
-        cachedMaxExpressionLength[start] = (int)Math.Min(sumOfMaxTrees, limit);
-      }
-      return cachedMaxExpressionLength[start];
-    }
-
-    private Dictionary<Symbol, int> cachedMinExpressionDepth;
-    public int GetMinExpressionDepth(Symbol start) {
-      if (!cachedMinExpressionDepth.ContainsKey(start)) {
-        cachedMinExpressionDepth[start] = int.MaxValue; // prevent infinite recursion
-        cachedMinExpressionDepth[start] = 1 + (from argIndex in Enumerable.Range(0, GetMinSubTreeCount(start))
-                                               let minForSlot = (from symbol in GetAllowedSymbols(start, argIndex)
-                                                                 select GetMinExpressionDepth(symbol)).DefaultIfEmpty(0).Min()
-                                               select minForSlot).DefaultIfEmpty(0).Max();
-      }
-      return cachedMinExpressionDepth[start];
-    }
-
-    public int GetMinSubTreeCount(Symbol start) {
-      return minSubTreeCount[start.Name];
-    }
-
-    public int GetMaxSubTreeCount(Symbol start) {
-      return maxSubTreeCount[start.Name];
-    }
-
-    public bool IsValidExpression(SymbolicExpressionTree expression) {
-      if (expression.Root.Symbol != ProgramRootSymbol) return false;
-      // check dynamic symbols
-      foreach (var branch in expression.Root.SubTrees) {
-        foreach (var dynamicNode in branch.DynamicSymbols) {
-          if (!dynamicNode.StartsWith("ARG")) {
-            if (FindDefinitionOfDynamicFunction(expression.Root, dynamicNode) == null) return false;
-          }
-        }
-      }
-      return IsValidExpression(expression.Root);
-    }
-
-    #endregion
-    private bool IsValidExpression(SymbolicExpressionTreeNode root) {
-      if (root.SubTrees.Count < GetMinSubTreeCount(root.Symbol)) return false;
-      if (root.SubTrees.Count > GetMaxSubTreeCount(root.Symbol)) return false;
-      if (root.Symbol is Defun || root.Symbol is StartSymbol) {
-        // check references to dynamic symbols
-        if (!CheckDynamicSymbolsInBranch(root, root.SubTrees[0])) return false;
-      }
-      for (int i = 0; i < root.SubTrees.Count; i++) {
-        if (!GetAllowedSymbols(root.Symbol, i).Contains(root.SubTrees[i].Symbol)) return false;
-        if (!IsValidExpression(root.SubTrees[i])) return false;
-      }
-      return true;
-    }
-
-    private SymbolicExpressionTreeNode FindDefinitionOfDynamicFunction(SymbolicExpressionTreeNode root, string dynamicNode) {
-      return (from node in root.SubTrees.OfType<DefunTreeNode>()
-              where node.Name == dynamicNode
-              select node).FirstOrDefault();
-    }
-
-    private bool CheckDynamicSymbolsInBranch(SymbolicExpressionTreeNode root, SymbolicExpressionTreeNode node) {
-      var argNode = node as ArgumentTreeNode;
-      var invokeNode = node as InvokeFunctionTreeNode;
-      if (argNode != null) {
-        if (!root.DynamicSymbols.Contains("ARG" + argNode.ArgumentIndex)) return false;
-      } else if (invokeNode != null) {
-        if (!root.DynamicSymbols.Contains(invokeNode.InvokedFunctionName)) return false;
-        if (root.GetDynamicSymbolArgumentCount(invokeNode.InvokedFunctionName) != invokeNode.SubTrees.Count()) return false;
-      }
-      foreach (var subtree in node.SubTrees) {
-        if (!CheckDynamicSymbolsInBranch(root, subtree)) return false;
-      }
-      return true;
-    }
-
+    //private void symbol_ToStringChanged(object sender, EventArgs e) {
+    //  OnToStringChanged();
+    //}
+
+    //private bool IsValidExpression(SymbolicExpressionTreeNode root) {
+    //  if (root.SubTrees.Count < root.GetMinSubtreeCount()) return false;
+    //  else if (root.SubTrees.Count > root.GetMaxSubtreeCount()) return false;
+    //  else for (int i = 0; i < root.SubTrees.Count; i++) {
+    //      if (!root.GetAllowedSymbols(i).Select(x => x.Name).Contains(root.SubTrees[i].Symbol.Name)) return false;
+    //      if (!IsValidExpression(root.SubTrees[i])) return false;
+    //    }
+    //  return true;
+    //}
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      DefaultSymbolicExpressionGrammar clone = (DefaultSymbolicExpressionGrammar)base.Clone(cloner);
+      clone.maxSubTreeCount = new Dictionary<string, int>(maxSubTreeCount);
+      clone.minSubTreeCount = new Dictionary<string, int>(minSubTreeCount);
+      clone.startSymbol = startSymbol;
+      clone.allowedChildSymbols = new Dictionary<string, List<HashSet<string>>>(allowedChildSymbols);
+      clone.allSymbols = new HashSet<Symbol>(allSymbols);
+      return clone;
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/EnumerableExtensions.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/EnumerableExtensions.cs	(revision 3338)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/EnumerableExtensions.cs	(revision 3338)
@@ -0,0 +1,43 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using System.Linq;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  public static class EnumerableExtensions {
+    public static T SelectRandom<T>(this IEnumerable<T> xs, IRandom random) {
+      var list = xs as IList<T>;
+      if (list != null) {
+        return list[random.Next(list.Count)];
+      } else {
+        list = xs.ToList();
+        return list[random.Next(list.Count)];
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/GlobalSymbolicExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/GlobalSymbolicExpressionGrammar.cs	(revision 3338)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/GlobalSymbolicExpressionGrammar.cs	(revision 3338)
@@ -0,0 +1,145 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  [StorableClass]
+  [Item("GlobalSymbolicExpressionGrammar", "Represents a grammar that defines the syntax of symbolic expression trees.")]
+  public class GlobalSymbolicExpressionGrammar : DefaultSymbolicExpressionGrammar {
+    [Storable]
+    private int minFunctionDefinitions;
+    public int MinFunctionDefinitions {
+      get { return minFunctionDefinitions; }
+      set { 
+        minFunctionDefinitions = value;
+        Reset();
+      }
+    }
+    [Storable]
+    private int maxFunctionDefinitions;
+    public int MaxFunctionDefinitions {
+      get { return maxFunctionDefinitions; }
+      set { 
+        maxFunctionDefinitions = value;
+        Reset();
+      }
+    }
+    [Storable]
+    private int minFunctionArguments;
+    public int MinFunctionArguments {
+      get { return minFunctionArguments; }
+      set { 
+        minFunctionArguments = value;
+        Reset();
+      }
+    }
+    [Storable]
+    private int maxFunctionArguments;
+    public int MaxFunctionArguments {
+      get { return maxFunctionArguments; }
+      set { 
+        maxFunctionArguments = value;
+        Reset();
+      }
+    }
+    [Storable]
+    private ISymbolicExpressionGrammar mainBranchGrammar;
+
+    public GlobalSymbolicExpressionGrammar() : base() { } // empty constructor for cloning
+
+    public GlobalSymbolicExpressionGrammar(ISymbolicExpressionGrammar mainBranchGrammar )
+      : base() {
+      maxFunctionArguments = 3;
+      maxFunctionDefinitions = 3;
+      this.mainBranchGrammar = mainBranchGrammar;
+      Initialize();
+    }
+
+    private void Reset() {
+      base.Reset();
+      Initialize();
+    }
+
+    private void Initialize() {
+      // remove the start symbol of the default grammar
+      RemoveSymbol(StartSymbol);
+
+      StartSymbol = new ProgramRootSymbol();
+      var defunSymbol = new Defun();
+      AddSymbol(StartSymbol);
+      AddSymbol(defunSymbol);
+
+      SetMinSubtreeCount(StartSymbol, minFunctionDefinitions + 1);
+      SetMaxSubtreeCount(StartSymbol, maxFunctionDefinitions + 1);
+      SetMinSubtreeCount(defunSymbol, 1);
+      SetMaxSubtreeCount(defunSymbol, 1);
+
+      // copy symbols from mainBranchGrammar
+      foreach (var symb in mainBranchGrammar.Symbols) {
+        AddSymbol(symb);
+        SetMinSubtreeCount(symb, mainBranchGrammar.GetMinSubtreeCount(symb));
+        SetMaxSubtreeCount(symb, mainBranchGrammar.GetMaxSubtreeCount(symb));
+      }
+
+      // the start symbol of the mainBranchGrammar is allowed as the result producing branch
+      SetAllowedChild(StartSymbol, mainBranchGrammar.StartSymbol, 0);
+
+      // ADF branches maxFunctionDefinitions 
+      for (int argumentIndex = 1; argumentIndex < maxFunctionDefinitions + 1; argumentIndex++) {
+        SetAllowedChild(StartSymbol, defunSymbol, argumentIndex);
+      }
+
+      // copy syntax constraints from mainBranchGrammar
+      foreach (var parent in mainBranchGrammar.Symbols) {
+        for (int i = 0; i < mainBranchGrammar.GetMaxSubtreeCount(parent); i++) {
+          foreach (var child in mainBranchGrammar.Symbols) {
+            if (mainBranchGrammar.IsAllowedChild(parent, child, i)) {
+              SetAllowedChild(parent, child, i);
+            }
+          }
+        }
+      }
+
+      // every symbol of the mainBranchGrammar that is allowed as child of the start symbol is also allowed as direct child of defun
+      foreach (var symb in mainBranchGrammar.Symbols) {
+        if (mainBranchGrammar.IsAllowedChild(mainBranchGrammar.StartSymbol, symb, 0))
+          SetAllowedChild(defunSymbol, symb, 0);
+      }
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      GlobalSymbolicExpressionGrammar clone = (GlobalSymbolicExpressionGrammar)base.Clone(cloner);
+      clone.maxFunctionArguments = maxFunctionArguments;
+      clone.maxFunctionDefinitions = maxFunctionDefinitions;
+      clone.minFunctionArguments = minFunctionArguments;
+      clone.minFunctionDefinitions = minFunctionDefinitions;
+      clone.mainBranchGrammar = mainBranchGrammar;
+      return clone;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj	(revision 3338)
@@ -83,15 +83,12 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="ArchitectureAlteringOperators\ArgumentDuplicater.cs" />
     <Compile Include="ArchitectureAlteringOperators\ArgumentCreater.cs" />
     <Compile Include="ArchitectureAlteringOperators\ArgumentDeleter.cs" />
-    <Compile Include="ArchitectureAlteringOperators\RandomArchitectureAlteringOperator.cs" />
-    <Compile Include="ArchitectureAlteringOperators\SubroutineDeleter.cs" />
-    <Compile Include="ArchitectureAlteringOperators\SubroutineCreater.cs">
+    <Compile Include="Crossovers\SubtreeCrossover.cs">
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="ArchitectureAlteringOperators\SubroutineDuplicater.cs">
-      <SubType>Code</SubType>
-    </Compile>
+    <Compile Include="GlobalSymbolicExpressionGrammar.cs" />
+    <Compile Include="EnumerableExtensions.cs" />
+    <Compile Include="Symbols\StartSymbolTreeNode.cs" />
     <Compile Include="DefaultSymbolicExpressionGrammar.cs">
       <SubType>Code</SubType>
@@ -103,5 +100,4 @@
     <Compile Include="SymbolicExpressionTreeManipulator.cs" />
     <Compile Include="SymbolicExpressionTreeTerminalNode.cs" />
-    <Compile Include="Crossovers\SubtreeCrossover.cs" />
     <Compile Include="Interfaces\ISymbolicExpressionGrammar.cs" />
     <Compile Include="Creators\ProbabilisticTreeCreator.cs" />
@@ -126,10 +122,4 @@
     <Compile Include="Symbols\Multiplication.cs" />
     <Compile Include="Symbols\Subtraction.cs" />
-    <Compile Include="Symbols\Values.cs">
-      <SubType>Code</SubType>
-    </Compile>
-    <Compile Include="Symbols\ValuesTreeNode.cs">
-      <SubType>Code</SubType>
-    </Compile>
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Interfaces/ISymbolicExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Interfaces/ISymbolicExpressionGrammar.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Interfaces/ISymbolicExpressionGrammar.cs	(revision 3338)
@@ -31,13 +31,16 @@
   public interface ISymbolicExpressionGrammar : IItem {
     Symbol StartSymbol { get; }
-    Symbol ProgramRootSymbol { get; }
-    IEnumerable<Symbol> GetAllowedSymbols(Symbol parent, int argumentIndex);
+    void AddSymbol(Symbol symbol);
+    void RemoveSymbol(Symbol symbol);
+    IEnumerable<Symbol> Symbols { get; }
+    void SetAllowedChild(Symbol parent, Symbol child, int argumentIndex);
+    bool IsAllowedChild(Symbol parent, Symbol child, int argumentIndex);
     int GetMinExpressionLength(Symbol start);
     int GetMaxExpressionLength(Symbol start);
     int GetMinExpressionDepth(Symbol start);
-    int GetMinSubTreeCount(Symbol start);
-    int GetMaxSubTreeCount(Symbol start);
-
-    bool IsValidExpression(SymbolicExpressionTree expression);
+    int GetMinSubtreeCount(Symbol symbol);
+    void SetMinSubtreeCount(Symbol symbol, int value);
+    int GetMaxSubtreeCount(Symbol symbol);
+    void SetMaxSubtreeCount(Symbol symbol, int value);
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs	(revision 3338)
@@ -50,7 +50,4 @@
     }
 
-    [Storable]
-    private Dictionary<int, IEnumerable<string>> allowedFunctionsInBranch;
-
     public int Size {
       get {
@@ -67,31 +64,22 @@
     public SymbolicExpressionTree()
       : base() {
-      allowedFunctionsInBranch = new Dictionary<int, IEnumerable<string>>();
     }
 
     public SymbolicExpressionTree(SymbolicExpressionTreeNode root)
       : base() {
-      allowedFunctionsInBranch = new Dictionary<int, IEnumerable<string>>();
     }
 
     public IEnumerable<SymbolicExpressionTreeNode> IterateNodesPrefix() {
-      return IterateNodesPrefix(root);
-    }
-    private IEnumerable<SymbolicExpressionTreeNode> IterateNodesPrefix(SymbolicExpressionTreeNode node) {
-      yield return node;
-      foreach (var subtree in node.SubTrees) {
-        foreach (var n in IterateNodesPrefix(subtree))
-          yield return n;
-      }
+      return root.IterateNodesPrefix();
     }
     public IEnumerable<SymbolicExpressionTreeNode> IterateNodesPostfix() {
-      return IterateNodesPostfix(root);
+      return root.IterateNodesPostfix();
     }
-    private IEnumerable<SymbolicExpressionTreeNode> IterateNodesPostfix(SymbolicExpressionTreeNode node) {
-      foreach (var subtree in node.SubTrees) {
-        foreach (var n in IterateNodesPrefix(subtree))
-          yield return n;
+
+    public SymbolicExpressionTreeNode GetTopLevelBranchOf(SymbolicExpressionTreeNode node) {
+      foreach (var branch in root.SubTrees) {
+        if (branch.IterateNodesPrefix().Contains(node)) return branch;
       }
-      yield return node;
+      throw new ArgumentException("Node was not found in tree.");
     }
 
@@ -101,6 +89,12 @@
       clone.ReadOnlyView = ReadOnlyView;
       clone.root = (SymbolicExpressionTreeNode)this.root.Clone();
-      clone.allowedFunctionsInBranch = new Dictionary<int, IEnumerable<string>>(allowedFunctionsInBranch);
       return clone;
+    }
+
+    public bool IsValidExpression() {
+      if (root.Symbol != root.Grammar.StartSymbol) return false;
+      foreach (var subtree in root.SubTrees)
+        if (subtree.Grammar == root.Grammar) return false;
+      return root.IsValidTree();
     }
   }
